<script lang="ts">
  import type { ChallengeWithSolves, ChallengeSubmission } from '@models/Challenges';
  import { Gql } from '@db';
  import { ChallengeWithSolvesQuery, ChallengeSubmissions } from '@models/Challenges';
  import { Table, Input } from '@sveltestrap/sveltestrap';
  import moment from 'moment';

  import { onMount } from 'svelte';
  import type { ChallengeSolve } from '@models/ChallengeSolve';
  import { EventRole } from '@auth/models';
  import { eventId } from '@stores';
  import SolvesPerTeam from '@components/CtfDashboard/SolvesPerTeam.svelte';

  let blurFlags = true;
  let challenges: ChallengeWithSolves[] = [];
  let submissions: ChallengeSubmission[] = [];
  let queryRole = EventRole.CTFAdmin;
  let showAllSubmissions = false;
  $: Gql.subscribeSimple<{ challenges_submissions: ChallengeSubmission[] }>(
    `subscription ${ChallengeSubmissions($eventId, showAllSubmissions ? 0 : 20)}`,
    (value) => (submissions = value.challenges_submissions),
    { queryRole },
  );

  onMount(async () => {
    Gql.subscribeSimple<{ challenges_challenges: ChallengeWithSolves[] }>(
      `subscription ${ChallengeWithSolvesQuery($eventId)}`,
      (value) => (challenges = value.challenges_challenges),
      { queryRole },
    );
  });

  /**
   * Returns the Locale Time the solve occurred if available, otherwise returns an empty string
   */
  function getSolveTime(solve?: ChallengeSolve): string {
    if (!solve?.time) return '';
    return new Date(solve.time).toLocaleString('en-US', {
      hour: 'numeric',
      minute: 'numeric',
      hour12: true,
    });
  }
</script>

<div class="d-flex align-self-center">
  <div class="d-flex">
    {#if challenges?.length !== undefined}
      <div class="p-2 d-flex flex-column">
        <h3 class="mt-4 align-self-center mb-4">Solves Per Challenge</h3>
        <Table class="text-white mt-5">
          <thead>
            <tr>
              <th>Name</th>
              <th>Category</th>
              <th>Points</th>
              <th>Designer</th>
              <th>Solves</th>
              <th>First</th>
              <th>Time</th>
            </tr>
          </thead>
          <tbody>
            {#each challenges as challenge}
              <tr>
                <td>{challenge.name}</td>
                <td>{challenge.category}</td>
                <td>{challenge.active?.[0]?.points}</td>
                <td>{challenge.designer}</td>
                <td>{challenge.solves.length}</td>
                <td>{challenge.solves.find((solve) => solve.challenge_id === challenge.id)?.team.name ?? ''}</td>
                <td>{getSolveTime(challenge.solves.find((solve) => (solve.challenge_id = challenge.id)))}</td>
              </tr>
            {/each}
          </tbody>
        </Table>
      </div>

      <div class="p-2 d-flex flex-column">
        <div>
          <h3 class="mt-4 align-self-center d-flex flex-column">Solves Per Team</h3>
          <SolvesPerTeam />
        </div>

        <div class="d-flex flex-column">
          <h3 class="mt-4 align-self-center d-flex flex-column">Flag Submissions</h3>
          <Input class="clickable align-self-center" type="switch" bind:checked={blurFlags} label="Blur Flags" />
          <Table class="text-white">
            <thead>
              <tr>
                <th>Challenge</th>
                <th>Team</th>
                <th>Flag</th>
                <th>Timestamp</th>
              </tr>
            </thead>
            <tbody>
              {#each submissions as submission}
                <tr>
                  <td style="min-width: 200px;">
                    {submission.challenge?.name}
                  </td>
                  <td style="min-width: 50px;">
                    {submission.team?.name}
                  </td>
                  <td class="{blurFlags ? 'overlay-blur' : ''} text-truncate" style="max-width: 400px;">
                    {submission.flag}
                  </td>
                  <td style="min-width: 150px;">
                    {moment(submission.time).fromNow()}
                  </td>
                </tr>
              {/each}
            </tbody>
          </Table>
          <div class="w-100 text-center">
            <a class="clickable" on:click={() => (showAllSubmissions = true)}>Show All</a>
          </div>
        </div>
      </div>
    {/if}
  </div>
</div>

<style>
  .overlay-blur {
    position: relative;
    filter: blur(5px);
  }
</style>
